<?php
/*
* SEF Advance extension for Docman, component for Joomla! CMS
*
* Copyright (C) 2007-2010 Emir Sakic, http://www.sakic.net
* Copyright (C) 2006 Marko Schmuck aka Predator, webmaster@open-sef.org, http://www.open-sef.org
*
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Comments: for Joomla!, SEF Advance and Docman 1.4-1.5
*/

/** ensure this file is being included by a parent file */
//defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class sef_docman {
	/**
	* Creates the SEF advance URL out of the Joomla! request
	**/
	function create ($string) {
		if (class_exists('JFactory')) {
			$db = &JFactory::getDbo();
		} else {
			global $database;
			$db = $database;
		}
		$sefstring = '';
		if ((stristr($string,'&amp;task=doc_details') ||
			stristr($string,'&amp;task=doc_edit') ||
			stristr($string,'&amp;task=doc_checkout') ||
			stristr($string,'&amp;task=doc_reset') ||
			stristr($string,'&amp;task=doc_move') ||
			stristr($string,'&amp;task=doc_delete') ||
			stristr($string,'&amp;task=doc_update') ||
			stristr($string,'&amp;task=doc_view') ||
			stristr($string,'&amp;task=doc_unpublish') ||
			stristr($string,'&amp;task=doc_publish')) &&
			stristr($string,'&amp;gid=')) {

			if (stristr($string,'&amp;task=')) {
				$temp = explode('&amp;task=', $string);
				$temp = explode('&', $temp[1]);
				$sefstring .= $temp[0]."/";
			}
			if (stristr($string,'&amp;gid=')) {
				$temp = explode('&amp;gid=', $string);
				$temp = explode('&', $temp[1]);
				$db->setQuery("SELECT dmname FROM #__docman WHERE id=".$temp[0]);
				$sefstring .= sefencode($db->loadResult()).'/';
			}
		} else if (stristr($string,'&amp;task=upload') || stristr($string,'&amp;task=search_')) {
			$temp = explode('&amp;task=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0]."/";
		} else if (stristr($string,'&amp;task=license_result') && stristr($string,'&amp;gid=')) {
			$temp = explode('&amp;task=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0]."/";
			$temp = explode("&amp;gid=", $string);
			$temp = explode("&", $temp[1]);
			$db->setQuery("SELECT dmname FROM #__docman WHERE id=".$temp[0]);
			$sefstring .= sefencode($db->loadResult())."/";
			$temp = explode('&amp;bid=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0]."/";
		} else if (stristr($string,'&amp;task=doc_download')) {
			$sefstring .= 'download/';
			$temp = explode('&amp;gid=', $string);
			$temp = explode('&', $temp[1]);
			$db->setQuery("SELECT dmname FROM #__docman WHERE id=".$temp[0]);
			$sefstring .= sefencode($db->loadResult()).'/';
		} else if (stristr($string,'&amp;gid=')) {
			$temp = explode('&amp;gid=', $string);
			$temp = explode('&', $temp[1]);
			$id = $temp[0];
			$url_array = array();
			$has_parent = true;
			while($has_parent) {
				$db->setQuery("SELECT title, parent_id FROM #__categories WHERE id=".$id);
				$rows = $db->loadObjectList();
				$row = $rows[0];
				$has_parent = $row->parent_id == 0 ? false : true;
				$id = $row->parent_id;
				$url_array[] = sefencode($row->title);
			}
			$url_array = array_reverse($url_array);
			$sefstring .= implode('/',$url_array).'/';
		}

		if (stristr($string,'&amp;limit=')) {
			$temp = explode('&amp;limit=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0].'/';
		}
		if (stristr($string,'&amp;limitstart=')) {
			$temp = explode('&amp;limitstart=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0].'/';
		}
		if (stristr($string,'&amp;order=')) {
			$temp = explode('&amp;order=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0].'/';
		}
		if (stristr($string,'&amp;dir=')) {
			$temp = explode('&amp;dir=', $string);
			$temp = explode('&', $temp[1]);
			$sefstring .= $temp[0].'/';
		}

		return $sefstring;
	}
 	/**
	* Reverts to the Joomla query string out of the SEF advance URL
	**/
 	function revert ($url_array, $pos) {
		if (class_exists('JFactory')) {
			$db = &JFactory::getDbo();
		} else {
			global $database;
			$db = $database;
		}
 		$QUERY_STRING = '';
		if (isset($url_array[$pos+2]) && $url_array[$pos+2]=='download') {
			$task = 'doc_download';
			$_GET['task'] = $_REQUEST['task'] = $task;
			$dmname = sefdecode($url_array[$pos+3]);
			$db->setQuery("SELECT id "
				."FROM #__docman "
				."WHERE dmname='$dmname'");
			$gid = $db->loadResult();
			$_GET['gid'] = $_REQUEST['gid'] = $gid;
			$QUERY_STRING .= "&task=$task&gid=$gid";
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]=='license_result') {
			$task = $url_array[$pos+2];
			$_GET['task'] = $_REQUEST['task'] = $task;
			$dmname = sefdecode($url_array[$pos+3]);
			$db->setQuery("SELECT id "
				."FROM #__docman "
				."WHERE dmname='$dmname'");
			$gid = $db->loadResult();
			$_GET['gid'] = $_REQUEST['gid'] = $gid;
			$bid = $url_array[$pos+4];
			$_GET['bid'] = $_REQUEST['bid'] = $bid;
			$QUERY_STRING .= "&task=$task&gid=$gid&Itemid=$Itemid&bid=$bid";
		} else if (isset($url_array[$pos+2]) && ($url_array[$pos+2]=='search_form' || $url_array[$pos+2]=='search_result' || $url_array[$pos+2]=='upload')) {
			$task = $url_array[$pos+2];
			$_GET['task'] = $_REQUEST['task'] = $task;
			$QUERY_STRING .= "&task=$task";
		} else if (isset($url_array[$pos+2]) &&
        	($url_array[$pos+2]   == "doc_details" ||
        	$url_array[$pos+2]    == "doc_edit" ||
        	$url_array[$pos+2]    == "doc_checkout" ||
        	$url_array[$pos+2]    == "doc_reset" ||
        	$url_array[$pos+2]    == "doc_move" ||
        	$url_array[$pos+2]    == "doc_delete" ||
        	$url_array[$pos+2]    == "doc_update" ||
			$url_array[$pos+2]    == "doc_view" ||
        	$url_array[$pos+2]    == "doc_unpublish" ||
        	$url_array[$pos+2]    == "doc_publish")) {
			$dmname = sefdecode($url_array[$pos+3]);
			$db->setQuery("SELECT id "
				."FROM #__docman "
				."WHERE dmname='$dmname'");
			$gid = $db->loadResult();
			$_GET['gid'] = $_REQUEST['gid'] = $gid;
			$task = $url_array[$pos+2];
			$_GET['task'] = $_REQUEST['task'] = $task;
			$QUERY_STRING .= "&task=$task&gid=$gid";
		} else if (isset($url_array[$pos+2]) && $url_array[$pos+2]!='') {
			$has_child = true;
			while($has_child) {
				$catname = sefdecode($url_array[$pos+2]);
				if (!empty($url_array[$pos+3]) && !(is_numeric($url_array[$pos+3]) && strlen($url_array[$pos+3])<4)) {
					$has_child = true;
					$pos++;
				} else {
					$has_child = false;
				}
			}
			$db->setQuery("SELECT id "
				."FROM #__categories "
				."WHERE title='$catname'");
			$gid = $db->loadResult();
			$_GET['gid'] = $_REQUEST['gid'] = $gid;
			$task = 'cat_view';
			$_GET['task'] = $_REQUEST['task'] = $task;
			$QUERY_STRING .= "&task=$task&gid=$gid";

			if (isset($url_array[$pos+3]) && $url_array[$pos+3]!='') {
				$limit = $url_array[$pos+3];
				$_GET['limit'] = $_REQUEST['limit'] = $limit;
				$QUERY_STRING .= "&limit=$limit";
			}
			if (isset($url_array[$pos+4]) && $url_array[$pos+4]!='') {
				$limitstart = $url_array[$pos+4];
				$_GET['limitstart'] = $_REQUEST['limitstart'] = $limitstart;
				$QUERY_STRING .= "&limitstart=$limitstart";
			}
			if (isset($url_array[$pos+5]) && $url_array[$pos+5]!='') {
				$order = $url_array[$pos+5];
				$_GET['order'] = $_REQUEST['order'] = $order;
				$QUERY_STRING .= "&order=$order";
			}
			if (isset($url_array[$pos+6]) && $url_array[$pos+6]!='') {
				$dir = $url_array[$pos+6];
				$_GET['dir'] = $_REQUEST['dir'] = $dir;
				$QUERY_STRING .= "&dir=$dir";
			}

		}
		return $QUERY_STRING;
	}
}
?>